/** 
 * bleifrei utility library
 *
 * Copyright (C) 2003 Ulf Borgenstam, Jonas Svensson.
 *
 * Do not distribute. If you know someone interested in obtaining these sources
 * please have them contact us.
 */

#ifndef _include_bleifrei_Scene_hpp_
#define _include_bleifrei_Scene_hpp_


// includes
#include <iostream>
#include <vector>

#include "../Base.hpp"

#include "Material.hpp"

namespace bleifrei {
	namespace scene {

		class Mesh;

		class Scene : public Base {
		public:
			Scene(void);
			virtual ~Scene(void);

			void insert(Mesh *mesh);
			unsigned int add(Material &material);

			std::vector<Mesh *> &getMeshes(void)				{ return meshes;						}
			std::vector<Material> &getMaterials(void)			{ return materials;						}

			void read(std::istream &is);
			void write(std::ostream &os);

		private:
			std::vector<Mesh *> meshes;
			std::vector<Material> materials;
		};

	}
}

#endif //_include_bleifrei_Scene_hpp_
