
// includes
#include "bleifrei/gfx/Font.hpp"
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/input/Mouse.hpp"
#include "bleifrei/tex/Texture.hpp"
#include "bleifrei/tex/TextureManager.hpp"
#include "MousePointer.hpp"

using namespace bleifrei::gfx;
using namespace bleifrei::input;
using namespace bleifrei::tex;
using namespace std;

extern int g_width;
extern int g_height;

MousePointer::MousePointer(const string &texture, Font *font)
{
	m_texture = TextureManager::getInstance().load(texture);
	m_font = font;
}

MousePointer::~MousePointer(void)
{
}

void
MousePointer::render(void)
{
	if (!m_show) return;

	int mouseX, mouseY;
	Mouse::getInstance().getPosition(mouseX, mouseY);

	m_texture->bind();

	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0.5f);
	glColor3f(192.0f / 255.0f, 192.0f / 255.0f, 192.0f / 255.0f);
	glBegin(GL_QUADS);
	{
		glTexCoord2f(0.0f, 1.0f);
		glVertex2i(mouseX - 7, mouseY - 7);
		glTexCoord2f(0.0f, 0.0f + 1 / 16.0f);
		glVertex2i(mouseX - 7, mouseY + 8);
		glTexCoord2f(1.0f - 1 / 16.0f, 0.0f + 1 / 16.0f);
		glVertex2i(mouseX + 8, mouseY + 8);
		glTexCoord2f(1.0f - 1 / 16.0f, 1.0f);
		glVertex2i(mouseX + 8, mouseY - 7);

		int offsetX = mouseX % 2;
		glTexCoord2f(0.0f, 0.0f);
		glVertex2i(offsetX, mouseY);
		glTexCoord2f(0.0f, 1 / 16.0f);
		glVertex2i(offsetX, mouseY + 1);
		glTexCoord2f(g_width / 16.0f, 1 / 16.0f);
		glVertex2i(g_width + offsetX, mouseY + 1);
		glTexCoord2f(g_width /16.0f, 0.0f);
		glVertex2i(g_width + offsetX, mouseY);

		int offsetY = mouseY % 2;
		glTexCoord2f(0.0f, 0.0f);
		glVertex2i(mouseX, offsetY);
		glTexCoord2f(0.0f, 1 / 16.0f);
		glVertex2i(mouseX + 1, offsetY);
		glTexCoord2f(g_height / 16.0f, 1 / 16.0f);
		glVertex2i(mouseX + 1, g_height + offsetY);
		glTexCoord2f(g_height /16.0f, 0.0f);
		glVertex2i(mouseX, g_height + offsetY);
	}
	glEnd();
	glColor3f(98 / 255.0f, 142 / 255.0f, 181 / 255.0f);
	m_font->printf(2, mouseY - m_font->getHeight(), 1.0f, "y=%i", mouseY);
	m_font->printf(mouseX + 2, 1, 1.0f, "x=%i", mouseX);
	glDisable(GL_ALPHA_TEST);
}